
/*
 *     Example of a connection-oriented client using TCP protocol.
 *
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#define SERVER_TCP_PORT     7000
#define SERVER_HOST_ADDR    "128.230.23.8"
#define MAX_MSG_SIZE        2048

char *hello = "Hello Server !\n";

main()
{
     int sockfd, n;
     struct sockaddr_in serv_addr;
     char message[MAX_MSG_SIZE];

     /*
      * Open a TCP socket (an Internet stream socket).
      */

     if ( ( sockfd = socket(AF_INET, SOCK_STREAM, 0) ) < 0 ) {
        fprintf(stderr, "client: can't open stream socket.");
        exit(1);
     }

     /*
      * Specify the server address to connect.
      */

     bzero((char *) &serv_addr, sizeof(serv_addr));           /* Initialize  */
     serv_addr.sin_family      = AF_INET;                     /* Internet    */
     serv_addr.sin_port        = htons(SERVER_TCP_PORT);      /* Port number */
     serv_addr.sin_addr.s_addr = inet_addr(SERVER_HOST_ADDR); /* Host addr   */

     /*
      * Connect to the server.
      */

     if (connect(sockfd,(struct sockaddr *)&serv_addr,sizeof(serv_addr)) < 0) {
        fprintf(stderr, "client: can't connect to the server.");
        exit(1);
     }

     /*
      * Do a specific task for the client.
      */

     n = strlen(hello);
     if ( write(sockfd, hello, n) != n ) {
        fprintf(stderr, "client: can't write into the socket.\n");
        exit(1);
     }
     if ( ( n = read(sockfd, message, MAX_MSG_SIZE) ) < 0 ) {
        fprintf(stderr, "client: can't read from the socket.\n");
        exit(1);
     }
     message[n] = '\0';
     printf("%s", message);

     /*
      * Close used socket.
      */

     close(sockfd);
     exit(0);
}

