/*************************************************************************

	File Name	: PlotType.java

	Function	: Get the plot type of the graph

	Input		:

		CFD smain	  : CFD main class

**************************************************************************/

import java.awt.*;
import java.util.*;
import java.lang.*;
import java.awt.event.*;
import java.applet.Applet;

public class PlotType extends Panel {

	CFD smain;

	// item
	Choice plotType;

	// message variables
	String messageSpace	= " ";

	String messageToBeSent	= null;
	String messageHead	= "3";
	String messageTotalData	= null;
	String messageType	= "31";
	String messageBody	= null;
	String messageEnd	= "kimd";

       /*****************************************************************
	*
	*	method	 : maketitle()
	*	Input    : String name,
	*		   GridBagLayout gridbag,
	*		   GridBagConstraints c
	*	Output   : none
	*	Function : make a title of this class
	*
	*****************************************************************/
	protected void maketitle(
				String name,
				GridBagLayout gridbag,
				GridBagConstraints c) {
		Label label = new Label(name);
		// Font for Panel Title
		label.setFont(new Font("Dialog", Font.BOLD, 10));
		gridbag.setConstraints(label, c);
		add(label);
	}

       /*****************************************************************
	*
	*	method	 : makelabel()
	*	Input    : String name,
	*		   GridBagLayout gridbag,
	*		   GridBagConstraints c
	*	Output   : none
	*	Function : make a label
	*
	*****************************************************************/
	protected void makelabel(
				String name,
				GridBagLayout gridbag,
				GridBagConstraints c) {
		Label label = new Label(name);
		// Font for label
		label.setFont(new Font("Dialog", Font.PLAIN, 8));
		gridbag.setConstraints(label, c);
		add(label);
	}

       /*****************************************************************
	*
	*	method	 : PlotType()
	*
	*	Function : constructor of this class
	*
	*****************************************************************/
	PlotType(CFD smain) {

		this.smain = smain;

		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridbag);

		// Font for Panel Main
		setFont(new Font("Dialog", Font.PLAIN, 10));

		c.fill = GridBagConstraints.CENTER;

		// title

		c.insets = new Insets(4, 0, 0, 0);

		c.gridwidth = GridBagConstraints.REMAINDER;
		c.weightx = 1.0;

		plotType = new Choice();
		plotType.addItem(" Vector");
		plotType.addItem(" Bar");
		plotType.addItem(" Streamline ");
		add(plotType);
		gridbag.setConstraints(plotType, c);
	}

       /*****************************************************************
	*
	*	method	 : handleEvent()
	*	Input    : Event event
	*	Output   : boolean
	*
	*****************************************************************/
	public boolean handleEvent(Event event) {

		if (event.target == plotType && event.id == Event.ACTION_EVENT) {
			plotType_Changed(event);
		}

		return false;
	}

       /*****************************************************************
	*
	*	method	 : plotType_Changed()
	*	Input    : Event event
	*	Output   : none
	*	Function : Action when the plot type is changed
	*
	*****************************************************************/
	void plotType_Changed(Event event) {

		int newPlotType = plotType.getSelectedIndex();

		if (smain.plotType_main != newPlotType) {
			smain.plotType_main = newPlotType;
		}
		else {
			return;
		}

		messageTotalData = Integer.toString(smain.numOfSource);

		messageToBeSent = messageHead + messageSpace
				+ messageTotalData + messageSpace
				+ messageType + messageSpace
				+ Integer.toString(smain.plotType_main) + messageSpace
				+ messageEnd;

		smain.send_message(messageToBeSent);
	}
}
