/*************************************************************************

	File Name	: sv2.java

		Application for SV2.
		application only version.

**************************************************************************/

import java.io.*;
import java.net.*;
import java.awt.*;
import java.util.*;
import java.lang.*;
import java.awt.event.*;
import java.applet.Applet;

import webwisdom.tango.*;
import sv.engine.SV2Engine;

/**
 * start the sv2 from the console
 */

public class startSV2 extends Applet implements TDataListener, TControlListener {

  //////////////////////////////////////////////////////////////////
  // It waste the memory space. But still useful.
    //public class SV2 extends Applet implements TDataListener, TControlListener {

  static String version = "1.001_110698";
  String allArgs[] = new String[50];
  int argLength;
  boolean testSV2 = false;
  String configDir = null;

	// TANGO variables
	TAgent agent = null;
	boolean	isMaster = true;
	String	MyName = null;

	private int channel = 15;
	private boolean javaOnly = true;
	boolean inTango = true;
	boolean fromScript = false;

	String serverName = null;

	HostSelection hostSelection;

	// message variables
	String messageReceive	= null;

	public final static String messageSpace	= " ";
	public final static String messageInitial	= "Initial";
	public final static String messageServerName	= "ServerName";
	public final static String messageEnd		= "kimd";

	boolean debugApplet = true;

	public void printLine(String printData) {
		if ( debugApplet ) {
			System.out.println(printData);
		}
	}

	public void initThis() {

	  isMaster = agent.isMaster();

	  if ( isMaster ) {
	    Frame f = new selectionMain(this);
	    f.setSize(175, 110);
	    f.show();
	  }
	  else {
	    initApplet();
	  }

	  /**
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridbag);

		setBackground(Color.lightGray);

		c.fill = GridBagConstraints.CENTER;

		//host selection
		c.weightx = 1;
		c.weighty = 1;
		c.gridwidth = GridBagConstraints.REMAINDER;
		OutlinePanel outHostSelection = new OutlinePanel(this, "Host Selection", 15, 10, 5, 25);
		outHostSelection.add("Center", hostSelection = new HostSelection(this));
		gridbag.setConstraints(outHostSelection, c);
		add(outHostSelection);
	**/
	}

	public void initApplet() {

		if ( inTango ) {
			// slave sends the initial request
			if ( !isMaster) {
				String message =  messageInitial + messageSpace
						+ messageEnd;
				sendMessage(message);
			}
		}
		else {
			isMaster = true;
		}
	}

	public void startThis() {
		printLine("<SV2> startThis()");
	}

	public void commJava() {

		try {
			agent = new TAgent(new TLAgentApplet(this));
		}
		catch(TangoException e) {
			e.printStackTrace();
			System.out.println("<SV2> agent is not proprely assigned");
		}

	}

	public void commJavaScript() {

//		JSObject jsWin = JSObject.getWindow(this);
//		Object[] args = new Object[1];
//		args[0] = this;
//		jsWin.call("appletReadyJS", args);
	}

	public void setTango(String arg) {
                if ( arg.equals("javaApplet") ) {
			fromScript = false;
			commJava();
		}
		else if ( arg.equals("javaScript") ) {
			fromScript = true;
			commJavaScript();
		}

		while ( agent == null ) {
			printLine("<SV2> waiting for the agent to be assigned");
		}
		printLine("<SV2> agent assigned");

		//dataListener = agent.addTDataListener(channel, this);
		//controlListener = agent.addTControlListener(this);
		agent.addTDataListener(channel, this);
		agent.addTControlListener(this);
		isMaster = agent.isMaster();
	}

	public int setTango(String args[]) {

		try {
			agent = new TAgent(new TLAgentApplication(args));
		}
		catch(TangoException e) {
			e.printStackTrace();
			System.out.println("<SV2> agent is not proprely assigned");
		}

		printLine("<SV2> Application2 agent assigned");

		agent.addTDataListener(channel, this);
		printLine("<SV2> Data added");

		agent.addTControlListener(this);
		printLine("<SV2> Control added");

//		isMaster = agent.isMaster();
		printLine("<SV2> Data Control added");
		printLine("<SV2> tango is setup in SV2");
		return 1;
	}

	public void initTangoJS(TAgent a, Number ch, Number ma) {

		channel = ((Number) ch).intValue();

		if ( ((Number) ma).intValue() ==  0 ) {
			isMaster = true;
		}
		else {
			isMaster = false;
		}

		agent = a;
	}

	public void channelReceive(int ch, byte b[]) {
		if ( channel != ch ) {
			return;
		}

		receive(b);
	}

	public void masterChangedJS(Number ma, String masterName) {
		if ( ((Number) ma).intValue() ==  0 ) {
			isMaster = true;
		}
		else {
			isMaster = false;
		}
	}

       /*****************************************************************
	*
	*	method	 : masterchanged()
	*	Input    : boolean master, String masterName
	*	Output   : none
	*	Function : Built-in function for TControlListener
	*
	*****************************************************************/
	public void masterChanged(boolean master, String masterName) {
		isMaster = master;
	}

       /*****************************************************************
	*
	*	method	 : participantJoined()
	*	Input    : String participantName
	*	Output   : none
	*	Function : Built-in function for TControlListener
	*
	*****************************************************************/
	public void participantJoined(String participantName) {
	}

       /*****************************************************************
	*
	*	method	 : participantLeft()
	*	Input    : String participantName
	*	Output   : none
	*	Function : Built-in function for TControlListener
	*
	*****************************************************************/
	public void participantLeft(String participantName) {
	}

       /*****************************************************************
	*
	*	method	 : audioRequested()
	*	Input    : boolean isREquested
	*	Output   : none
	*	Function : Built-in function for TControlListener
	*
	*****************************************************************/
	public void audioRequested(boolean isREquested) {
	}

       /*****************************************************************
	*
	*	method	 : stringToByte()
	*	Input    : String s
	*	Output   : byte[]
	*	Function : convert String to Byte
	*
	*****************************************************************/
	private byte[] stringToBytes(String s) {
		int l = s.length();
		byte[] t = new byte[l];
		s.getBytes(0, l, t, 0);
		return t;
	}

       /*****************************************************************
	*
	*	method	 : bytesToString()
	*	Input    : byte t[]
	*	Output   : String
	*	Function : convert byte to String
	*
	*****************************************************************/
	private String bytesToString(byte t[]) {
		return new String(t, 0);
	}

       /*****************************************************************
	*
	*	method	 : destroy()
	*	Input    : none
	*	Output   : none
	*	Function : 
	*
	*****************************************************************/
	public void destroy() {
		printLine("<SV2> inside destroy()");

		if ( fromScript ) {
			agent.removeTControlListener(this);
			agent.removeTDataListener(this);
			printLine("<SV2> data and control removed");
			return;
		}

		if (agent != null) {
			agent.exit();
			accessServer("2");
		}
		super.destroy();
	}

       /*****************************************************************
	*
	*	method	 : sendMessage()
	*	Input    : String messageToBeSent
	*	Output   : none
	*	Function : send the message and draw it on the Graph
	*
	*****************************************************************/
	void sendMessage(String messageToBeSent) {

		if (inTango) {
			printLine("<SV2> send : " + messageToBeSent);
			agent.send(channel, stringToBytes(messageToBeSent));
		}
	}

       /*****************************************************************
	*
	*	method	 : receive()
	*	Input    : byte b[]
	*	Output   : none
	*	Function : built-in function of TDataListener
	*
	*****************************************************************/
	public void receive(byte b[]) {

		String recvMessage = bytesToString(b);

		printLine("<SV2> received : " + recvMessage);

		StringTokenizer selectedItem = null;
		selectedItem = new StringTokenizer(recvMessage);
		String head = selectedItem.nextToken();

		if ( head.equals(messageInitial) ) {
			String sendData =
					messageServerName + messageSpace +
					serverName + messageSpace +
					messageEnd;
			sendMessage(sendData);
		}
		else if ( head.equals(messageServerName) ) {
			serverName = selectedItem.nextToken();
			//invokeSV2();
			coreSV2();
		}
	}

  public void accessServer(String action) {
    printLine("inside invokeServer");

    OutputStream    Outfile = null;
    PrintStream     outfile = null;

    printLine("\nCreating client socket\n");
    Socket csock = null;
    InetAddress addr = null;
    try {
      addr = InetAddress.getByName("osprey1.npac.syr.edu");
    }
    catch (UnknownHostException e1) {
      printLine("HOST error");
    }

    int socketno = 7000;
    printLine("##addr=" + addr.toString() + "  port=" + socketno + "##");

    boolean connected = false;
    int trial = 0;
    while (!connected) {
      try {
	csock = new Socket(addr, socketno);
	connected = true;
      }
      catch (IOException e1) {
	printLine("trying to create csocket");
	trial++;
      }
    }
    printLine("connected : trial " + trial);
    printLine("  created the client socket." + csock.toString());

    printLine("be going to write to the socket");
 
    try {
      Outfile = csock.getOutputStream();
      outfile = new PrintStream(Outfile);
    }   catch (IOException e1) { printLine("getOutputStream ERROR"); }
    printLine("NOW, writing\n");

    String sendData = null;
    sendData = action + " " + serverName;
    outfile.println(sendData);

    outfile.close();
    try {
      csock.close();
      System.out.println("DONE");
    }
    catch (IOException e1) {
      System.out.println("close socket ERROR");
    }

    if ( action.equals("1") ) {
      //invokeSV2();
      coreSV2();
    }
  }	

  public void invokeSV2() {
    printLine("inside invokeSV2");
    printLine("server : " + serverName);

    String testCommand = "d:\\Sv2\\sv2 " + serverName;
    //String testCommand = "/home/A10E/kimd/SV2/shell/testshell " + serverName;
    printLine("testCommand : " + testCommand );
    Process p;
    try {
      p = Runtime.getRuntime().exec(testCommand);
      printLine("test1-before : " + p);
      p.waitFor();
      printLine("test1-after : " + p);
    }
    catch(Exception e) {
      System.out.println("Exception when calling command!");
      e.printStackTrace();
    }

    if ( isMaster ) {
      //accessServer("2");
    }

  }

  public void coreSV2() {

    if ( testSV2 ) {
      return;
    }

    int j;
    for ( j = 0 ; j < 1000 ; j++ ) {
    }

    printLine("<SV2> core sv2 started");

    String shost = null;
    int sport = 7653;       
    int cport = 7654;

    boolean helpOption = false;   
    String setting = null;
    String cache = null;

    try {
      int i = 5;

      while (i < argLength) {
        if (allArgs[i].startsWith("-")) {
           String arg = allArgs[i++];

           if (arg.equals("-cp")) {
             cport = Integer.valueOf(allArgs[i++]).intValue();
           } else if (arg.equals("-sp")) {
             sport = Integer.valueOf(allArgs[i++]).intValue();
           } else if (arg.equals("-sh")) {
             shost = allArgs[i++];
           } else if (arg.equals("-c")) {
             setting = allArgs[i++];
           } else if (arg.equals("-cache")) {
             cache = allArgs[i++];
           } else if (arg.equals("-v")) {
             i++;
             System.err.println("The option -v is not defined yet.");
           } else if (arg.equals("-h") || arg.equals("-?")) {
             helpOption = true;
             break;
           } else {
             helpOption = true;
             break;
           }
        }  
      }
    } catch (Exception e) {
      helpOption = true;
    }

    shost = serverName;

    if (helpOption) {
      System.err.println("Usage: java startSV2 [options]");

      System.err.println("\nOptions:");
      System.err.println("   [-sh server_name] server host name");
      System.err.println("   [-sp server_port] server port number");
      System.err.println("   [-cp client_port] client(SV2) port number");
      System.err.println("   [-c config_dir] configuration directory");
      System.err.println("   [-cache cache_dir] cache directory");
      System.err.println("   [-v viewer_opt] visualization app option");
      System.err.println("   [-h | -?] help");
      System.exit(0);
    }     

    System.out.println("\nThe NPAC SV2(ver " + version + ") starts.");
    System.out.println("Written by Byeongseob Ki & Scott Klasky\n");
    new SV2Engine(shost, sport, cport, setting, cache,  
                 SV2Engine.COLLAB_BUILTIN, SV2Engine.VIEWER_BUILTIN);

  }

  /*****************************************************************
   *
   *	method	 : main()
   *
   *	Function : main function of this applet
   *
   *****************************************************************/
  public static void main(String args[]) {
    //Frame f = new Frame("SV2");
    startSV2 sv2 = new startSV2();
    String tangoArgs[] = new String[5];

    if ( args[0].equals("tango")) {
      sv2.inTango = true;
      int i;
      for ( i = 0 ; i < 5 ; i++ ) {
	tangoArgs[i] = args[i];
      }
    }

    if ( args[0].equals("test")) {
      sv2.testSV2 = true;
      sv2.inTango = false;
    }
    else {
      sv2.inTango = true;
      int i;
      for ( i = 0 ; i < 5 ; i++ ) {
	tangoArgs[i] = args[i];
      }
      sv2.configDir = args[0];
      sv2.printLine("configDir : " + sv2.configDir);
    }

    /**
      try {
      System.out.println("<SV2> arg[0] : " + args[0]);
      sv2.inTango = true;
      }
      catch (Exception e) {
      sv2.inTango = false;
      }
    **/

    sv2.printLine("<SV2> inTango : " + sv2.inTango);
    sv2.printLine("<SV2> args[0] : " + args[0]);

    if (sv2.inTango) {
      int i = sv2.setTango(tangoArgs);
    }

    int j;
    sv2.argLength = args.length;

    for ( j = 0 ; j < sv2.argLength ; j++ ) {
      sv2.allArgs[j] = args[j];
    }

    sv2.initThis();

  }

}
