
import java.io.*;
import java.net.*;
import sv.server.*;

/**
 * administate the sv2 server from the console
 */

public class adminSV2 {

  public static void main(String[] args) throws IOException {
  
    if (args.length < 1)
      printUsage();

    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    String line;
    int port = 7653;

    if (args[0].equalsIgnoreCase("start")) {
      String tmp = System.getProperty("os.name");
      String cache_dir = "/tmp/sv2/";

      if (tmp.indexOf("indow") > 0) 
        cache_dir = "C:\\temp\\sv2\\";

      try {
        System.out.println("Enter the server port number(7653): ");
        System.out.print("> ");
        line = in.readLine();
        if (line == null || line.length() < 1)
           port = 7653;
        else
           port = Integer.valueOf(line).intValue();

        System.out.println("Enter the cache directory(" + cache_dir + "): ");
        System.out.print("> ");
        line = in.readLine();
        if (line != null && line.length() > 0)
          cache_dir = line;

        System.out.print("\nThe NPAC SV2 server starts at ");
        System.out.println("port number " + port + ".\n");
   
        new SV2Server(port, cache_dir);

      } catch (Exception e) {
        System.out.println("Can't start the server:");
	//e.printStackTrace();
        System.exit(0);
      }
      
    } else if (args[0].equalsIgnoreCase("kill")) {
      try {
        System.out.println("Enter the server port number(7653): ");
        System.out.print("> ");
        line = in.readLine();
        if (line == null || line.length() < 1)
           port = 7653;
        else
           port = Integer.valueOf(line).intValue();

        Socket sock = new Socket(InetAddress.getLocalHost(), port);
        DataOutputStream output = new DataOutputStream(sock.getOutputStream());

        output.writeInt(666);                  // kill server command
        output.close();
        sock.close();

      } catch (Exception e) {
        System.out.println("Can't quit the server:");
        //e.printStackTrace();
        System.exit(0);
      }
      
    } else 
      printUsage();

    in.close();
  }

  static void printUsage() {
      System.err.println("Usage: java adminSV2 command");
      System.err.println("\nCommands:");
      System.err.println("   start - start the SV2 server");
      System.err.println("   kill  - kill the SV2 server");
      System.exit(0);
  }
} // end of class
