import sv.engine.SV2Engine;

/**
 * start the sv2 from the console
 */

public class startSV2 {

  //////////////////////////////////////////////////////////////////
  // It waste the memory space. But still useful.
  static String version = "1.001_110698";

  public static void main(String[] args) {
    String shost = null;
    int sport = 7653;       
    int cport = 7654;

    boolean helpOption = false;   
    String setting = null;
    String cache = null;

    try {
      int i = 0;

      while (i < args.length) {
        if (args[i].startsWith("-")) {
           String arg = args[i++];

           if (arg.equals("-cp")) {
             cport = Integer.valueOf(args[i++]).intValue();
           } else if (arg.equals("-sp")) {
             sport = Integer.valueOf(args[i++]).intValue();
           } else if (arg.equals("-sh")) {
             shost = args[i++];
           } else if (arg.equals("-c")) {
             setting = args[i++];
           } else if (arg.equals("-cache")) {
             cache = args[i++];
           } else if (arg.equals("-v")) {
             i++;
             System.err.println("The option -v is not defined yet.");
           } else if (arg.equals("-h") || arg.equals("-?")) {
             helpOption = true;
             break;
           } else {
             helpOption = true;
             break;
           }
        }  
      }
    } catch (Exception e) {
      helpOption = true;
    }

    if (helpOption) {
      System.err.println("Usage: java startSV2 [options]");

      System.err.println("\nOptions:");
      System.err.println("   [-sh server_name] server host name");
      System.err.println("   [-sp server_port] server port number");
      System.err.println("   [-cp client_port] client(SV2) port number");
      System.err.println("   [-c config_dir] configuration directory");
      System.err.println("   [-cache cache_dir] cache directory");
      System.err.println("   [-v viewer_opt] visualization app option");
      System.err.println("   [-h | -?] help");
      System.exit(0);
    }     

    System.out.println("\nThe NPAC SV2(ver " + version + ") starts.");
    System.out.println("Written by Byeongseob Ki & Scott Klasky\n");
    new SV2Engine(shost, sport, cport, setting, cache,  
                 SV2Engine.COLLAB_BUILTIN, SV2Engine.VIEWER_BUILTIN);
  }

} // end of class
