package sv.config;

import sv.engine.SV2Engine;

public class Config1D extends Configs {

  public final static int COLOR_BY_AMR  = 0;
  public final static int COLOR_BY_INFO = 1;
  public final static int COLOR_BY_DATA = 2;

  // panning and zooming position
  private int panX = 0;
  private int panY = 0;
  private float zoomfactor = 1.0f;

  int colorMode = COLOR_BY_DATA;
  boolean connect_point = false;
  boolean display_baseline = false;

  String xLabel = "X";
  String yLabel = "Y"; 

  /**
   * constructor
   */
  public Config1D(SV2Engine eng) {
    super(eng);
  }

  /**
   * get panX
   */
  public int getPanX() {
    return panX;
  }

  /**
   * set panX
   */
  public void setPanX(int val) {
    panX = val;
  }

  /**
   * get panY
   */
  public int getPanY() {
    return panY;
  }

  /**
   * set panY
   */
  public void setPanY(int val) {
    panY = val;
  }

  /**
   * get zoom factor
   */
  public float getZoomFactor() {
    return zoomfactor;
  }

  /**
   * set zoom factor
   */
  public void setZoomFactor(float f) {
    zoomfactor = f;
  }

  /** 
   * is connect point
   */
  public boolean isConnectPoints() {
    return connect_point;
  }

  /**
   * set connect point variable
   */
  public void setConnectPoints(boolean b) {
    connect_point = b;
  }

  /**
   * get color mode
   */
  public int getColorMode() {
    return colorMode;
  }

  /**
   * set color mode
   */
  public void setColorMode(int c) {
    colorMode = c;
  }

  /**
   * should it display the baseline
   */
  public boolean isBaseline() {
    return display_baseline;
  }

  /**
   * set if it displays baseline
   */
  public void setBaselineOpt(boolean b) {
    display_baseline = b;
  }

  
  /**
   * get x label
   */
  public String getXLabel() {
    return xLabel;
  }

  /**
   * set x label
   */
  public void setXLabel(String s) {
    xLabel = s;
  }

  /**
   * get y label
   */
  public String getYLabel() {
    return yLabel;
  }

  /**
   * set y label
   */
  public void setYLabel(String s) {
    yLabel = s;
  }

  /**
   * return  setting values
   */
  public String[] getConfigs() {
    return null;
  }

  /**
   * set setting values from the arguments
   */
  public void setConfigs(String[] args) {

  }

} // end of class

