package sv.config;

import java.awt.*;
import sv.engine.SV2Engine;
import javax.media.j3d.*;

public class Config3D extends Configs {

  /**
   * ray color        (VOLUME ONLY)
   */
  protected double[] rayColor = {0.5, 0.5, 1.0};

  /**
   * rotation x (-180 - 180)    (VOLUME ONLY)
   */
  protected double rotx = -30.0;

  /**
   * rotation y       (VOLUME ONLY)
   */
  protected double roty = 120.0;

  /**
   * plot mode
   */
  protected int plotmode = WIREFRAME;

  /**
   * bounding box
   */
  protected boolean boundingbox = true;

  /**
   * ambient color
   */
  protected float[] ambientColor = { 0.2f, 0.05f, 0.0f };
  
  /**
   * emissive color
   */
  protected float[] emissiveColor = { 0.0f, 0.0f, 0.0f };
 
  /**
   * diffuse color
   */
  protected float[] diffuseColor = { 0.8f, 0.2f, 0.2f };

  /**
   * specular color
   */
  protected float[] specularColor = { 0.7f, 0.7f, 0.7f };

  /**
   * shininess
   */
  protected float shininess = 75.0f;

    
  /**
   * cull
   */
  protected int cull = PolygonAttributes.CULL_NONE;


  /**
   * zoom value
   */
  protected int zoomValue;

  /**
   * x slider value
   */
  protected int xSliderValue;

  /**
   * y slider value
   */
  protected int ySliderValue;

  /**
   * z slider value
   */
  protected int zSliderValue;

  /**
   * constructor
   */
  public Config3D(SV2Engine eng) {
    super(eng);
    bgColor = new Color(0.05f, 0.05f, 0.2f);
  }


  /**
   * set plot mode
   */
  public void setPlotMode(int m) {
    plotmode = m;
  }

  /**
   * return plot mode
   */
  public int getPlotMode() {
    return plotmode;
  }

  /**
   * set bounding box mode
   */
  public void setBoungBox(boolean b) {
    boundingbox = b;
  }

  /**
   * return if bounding box will be drawn
   */
  public boolean isBoundingBox() {
    return boundingbox;
  }

  /** 
   * set ray color
   */
  public void setRayColor(double[] color) {
    rayColor = color;
  }

  /** 
   * return ray color
   */
  public double[] getRayColor() {
    return rayColor;
  }

  /**
   * set rotation (VOLUME ONLY)
   */
  public void setRotation(double x, double y) {
    rotx = x;
    roty = y;
  }

  /**
   * return x rotation value (VOLUME ONLY)
   */
  public double getRotationX() {
    return rotx;
  }

  /**
   * return y rotation value (VOLUME ONLY)
   */
  public double getRotationY() {
    return roty;
  }

  /**
   * set zoom value
   */
  public void setZoomValue(int v) {
    zoomValue = v;
  }

  /**
   * return zoom value
   */
  public int getZoomValue() {
    return zoomValue;
  }

  /**
   * set ambient color
   */
  public void setAmbientColor(float[] c) {
    ambientColor = c;
  }

  /**
   * get ambient color
   */
  public float[] getAmbientColor() {
    return ambientColor;
  }

  /**
   * set emissive color
   */
  public void setEmissiveColor(float[] c) {
    emissiveColor = c;
  }

  /**
   * get emissive color
   */
  public float[] getEmissiveColor() {
    return emissiveColor;
  }

  /**
   * set diffuse color
   */
  public void setDiffuseColor(float[] c) {
    diffuseColor = c;
  }

  /**
   * get diffuse color
   */
  public float[] getDiffuseColor() {
    return diffuseColor;
  }

  /**
   * set specular color
   */
  public void setSpecularColor(float[] c) {
    specularColor = c;
  }

  /**
   * get specular color
   */
  public float[] getSpecularColor() {
    return specularColor;
  }

  /**
   * set shininess 
   */
  public void setShininess(float c) {
    shininess = c;
  }

  /**
   * get shininess color
   */
  public float getShininess() {
    return shininess;
  }

  /**
   * set cull 
   */
  public void setCull(int c) {
    cull = c;
  }

  /**
   * get cull color
   */
  public int getCull() {
    return cull;
  }

  /**
   * set xSlider value
   */
  public void setXSliderValue(int v) {
    xSliderValue = v;
  }

  /**
   * return xSlider value
   */
  public int getXSliderValue() {
    return xSliderValue;
  }


  /**
   * set ySlider value
   */
  public void setYSliderValue(int v) {
    ySliderValue = v;
  }

  /**
   * return ySlider value
   */
  public int getYSliderValue() {
    return ySliderValue;
  }


  /**
   * set zSlider value
   */
  public void setZSliderValue(int v) {
    zSliderValue = v;
  }

  /**
   * return zSlider value
   */
  public int getZSliderValue() {
    return zSliderValue;
  }

  /**
   * return  setting values
   */
  public String[] getConfigs() {
    return null;
  }

  /**
   * set setting values from the arguments
   */
  public void setConfigs(String[] args) {

  }

} // end of class













