package sv.data;

import java.io.*;

public abstract class TimeData {

  public static final int ONED   = 1;
  public static final int TWOD   = 2;
  public static final int THREED = 3;

  /**
   * time value of this time data
   */
  protected TimeValue time;

  /**
   * rank of this time data
   */
  protected int rank;

  /**
   * the number of points
   */
  protected int noOfPoints;

  /**
   * return time value
   */
  public TimeValue getTime() {
     return time;
  }

  /**
   * return rank of this time data
   */
  public int getRank() {
    return rank;
  }

  /**
   * return noOfPoints
   */
  public int getNoOfPoints() {
    return noOfPoints;
  }    

  /**
   * send data by using DataOutputStream
   * This method will be used to save the data
   */
  public abstract void sendingData(DataOutputStream out) throws IOException;

  /**
   * return the size of this time data
   */
  public abstract long getDataSize();

}  // end of class




