package sv.engine;

import java.io.*;
import java.net.*;
import java.util.*;

public class cRecvChannel extends Thread {

  private ServerSocket sock = null;

  static SV2Engine engine;

  /**
   * constructor
   * @param eng parent module(SV2Engine)
   * @param p port for the server socket
   */
  public cRecvChannel(SV2Engine eng, int p) {
    engine = eng;

    try {
      sock = new ServerSocket(p);
    } catch(Exception e) { 
      System.err.println("Can't create server socket.");
      System.exit(1);
    }  
  }

  /**
   * waits for a connection 
   */
  public void run() {
    Vector convec = new Vector(5, 2);
     
    // continuously listen the socket
    while (true) {
      try {
         Socket incoming = sock.accept();
	
         cRecvHandler handler = new cRecvHandler(incoming, engine);
         handler.start();
         convec.addElement(handler);

         //clean up the vector if needed
         for (int i=0; i<convec.size(); i++)
           if (!((cRecvHandler)(convec.elementAt(i))).isAlive())
             convec.removeElementAt(i);

      } catch(Exception e) {
         System.err.println("Can't accept a connection by server socket.");
         return;
      }
    }
  }

} // end of class
