package sv.gui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import sv.data.TimeData3D;

public class RenderingChooser extends Dialog implements ActionListener {

  JRadioButton isoBtn, volBtn;

  int selected = -1;

  public RenderingChooser(Frame frame) {
    super(frame, "Rendering Choose", true);   // make it modal
    makeGUI();
    pack();
  }

  public void actionPerformed(ActionEvent e) {
    String command = e.getActionCommand();

    if (command.equals("Render")) {
      if (isoBtn.isSelected())
        selected = TimeData3D.ISOSURFACE_RENDERING;
      else
        selected = TimeData3D.VOLUME_RENDERING;
    } else if (command.equals("Cancel")) {
      selected = -1;
    }

    this.dispose();
  }

  /**
   * return selected item
   */
  public int getSelected() {
    return selected;
  }

  private void makeGUI() {
    setLayout(new BorderLayout(10, 10));

    JPanel p = new JPanel();
    p.setBorder(BorderFactory.createEmptyBorder(5, 10, 5, 10));
    p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
    ButtonGroup group = new ButtonGroup();
  
    JLabel label = new JLabel("Rendering Option: ");
    label.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
    p.add(label);
    p.add(isoBtn = new JRadioButton("Isosurface Rendering         "));
    p.add(volBtn = new JRadioButton("Volume Rendering             "));
    group.add(isoBtn);
    group.add(volBtn);
    isoBtn.setSelected(true);

    // button panel
    Panel p2 = new Panel();
    p2.setLayout(new FlowLayout(FlowLayout.RIGHT, 5, 5));

    Button btn = new Button("Render");
    btn.addActionListener(this);
    p2.add(btn);

    btn = new Button("Cancel");
    btn.addActionListener(this);
    p2.add(btn);

    add("Center", p);
    add("South", p2);
  }
}
