package sv.server.filter;

public class VolumeFilter {

  static double rayColorRed   = 0.5;
  static double rayColorGreen = 0.5;
  static double rayColorBlue  = 1.0;
  static double rotx          = -30.0;
  static double roty          = 120.0;

  /**
   * return all variables
   */
  public static double[] getVariables() {
    double[] vars = new double[5];
    vars[0] = rayColorRed;
    vars[1] = rayColorGreen;
    vars[2] = rayColorBlue;
    vars[3] = rotx;
    vars[4] = roty;
    return vars;
  }

  /**
   * set variables
   */
  public static void setVariables(double[] vars) {
    if (vars.length < 5) return;
    rayColorRed = vars[0]; 
    rayColorGreen = vars[1]; 
    rayColorBlue = vars[2]; 
    rotx = vars[3]; 
    roty = vars[4]; 
  }

  /**
   * precompute(classfying the volume) routine
   * @param name data name
   * @param rarr raw data array with float type
   * @param min min value of the array
   * @param max max value of the array
   * @param xlen x dimension of volume
   * @param ylen y dimension of volume
   * @param zlen z dimension of volume
   * @return 0 if success, -1 otherwise
   */ 
  public static native int precompute(String name, float[] rarr, 
                         float min, float max, int xlen, int ylen, int zlen);

  /**
   * execute filter with given data name
   * (render the volume and output with ppm file)
   * @param name data name
   * @param arr data array which contains output image
   * @return 0 if success, -1 otherwise
   */ 
  public static native int executeFilter(String name, byte[] arr);

  static {
    System.loadLibrary("VolFilter");
  }

} // end of class

