package sv.util;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

import javax.media.j3d.*;
import javax.vecmath.*;

// for java3d version

public class ContourObject {

  private Shape3D shape3D;

  public ContourObject(Point3f[] contourVerts) {
      Appearance app = new Appearance();

      int sz = contourVerts.length;

      LineArray lineArray = new LineArray(sz, LineArray.COORDINATES);
      lineArray.setCoordinates(0, contourVerts);

      // Set up the coloring properties
      Color3f objColor = new Color3f(1.0f, 0.4f, 0.0f);
      ColoringAttributes ca = new ColoringAttributes();
      ca.setColor(objColor);
      app.setColoringAttributes(ca);

      PolygonAttributes pa = new PolygonAttributes();
      pa.setCullFace(pa.CULL_NONE);
      app.setPolygonAttributes(pa);

      shape3D = new Shape3D(lineArray);
      shape3D.setAppearance(app);
  }

  public Shape3D getChild() {
     return shape3D;
  }

} // end of class
