package sv.util;

import java.util.*;

public class FilterMenuInfo {

  public int id;
  public int parent;
  public boolean isItem;
  public int level;
  public String name;
  public String className;
  public String directory;
  public int shortkey;
  public int rank;
  
  /**
   * filter menu information class constructor
   * @param n filter name
   * @param l level of the filter menu
   * @param i filter menu identification
   * @param p parent menu item
   * @param r filter rank
   */
  public FilterMenuInfo(String n, int l, int i, int p, int r) {
     id = i;
     parent = p;
     isItem = false;
     level = l;
     name = n;
     className = null;
     directory = null;
     shortkey = -1;
     rank = r;
  }  

  /**
   * filter menu information class constructor
   * @param n filter name
   * @param c filter class name
   * @param d filter directory
   * @param d shortkey of this filter (ALT+shortkey)
   * @param l level of the filter menu
   * @param i filter menu identification
   * @param p parent menu item
   * @param r filter rank
   */
  public FilterMenuInfo(String n, String c, String d, 
                                 int k, int l, int i, int p, int r) {
     id = i;
     parent = p;
     isItem = true;
     level = l;
     name = n;
     className = c;
     directory = d;
     shortkey = k;
     rank = r;
  }

  public void dump() {
     System.out.println("\n==============================");
     System.out.println("id = " + id);
     System.out.println("parent =  " + parent);
     System.out.println("level =  " + level);
     System.out.println("name =  " + name);
     System.out.println("className =  " + className);
     System.out.println("package = " + directory);
     System.out.println("shortkey =  " + shortkey);
     System.out.println("rank =  " + rank);
  }

} // end of class
