package sv.util;

// for java 3d version

public class GridInfo3D {
  float[] grid;
  int skipmode = -1;
  int extraction = -1;

  float vmin = Float.MAX_VALUE, vmax = Float.MIN_VALUE;

  public GridInfo3D(int size, int mode, int extraction) {
     grid = new float[size];
     skipmode = mode;
     this.extraction = extraction;
  }

  public void setValue(int pos, float val) {
     grid[pos] = val;
     if (val < vmin) vmin = val;
     if (val > vmax) vmax = val;
  }

  public int getSkipmode() {
     return skipmode;
  }

  public float getValue(int pos) {
     return grid[pos];
  }

  public int getSize() {
     return grid.length;
  }

  public int getExtraction() {
     return extraction;
  }

  public float getMin() {
     return vmin;
  }

  public float getMax() {
     return vmax;
  }


} // end of class


