package sv.util;

import java.awt.*;
import javax.vecmath.*;

// for java 3d version 

public final class J3DFace {
   public J3DVertex[] vertex; 
   public Vector3f normal;
   public Vector3f[] normal2;

   /**
    * The constructor of J3DFace. 
    * if b is true, then calc normal
    */
   public J3DFace(J3DVertex[] vtx, Vector3f[] norm, boolean b) {
     vertex = new J3DVertex[vtx.length];
     System.arraycopy(vtx, 0, vertex, 0, vtx.length);

     normal2 = new Vector3f[vtx.length];
     System.arraycopy(norm, 0, normal2, 0, vtx.length);

     if (vtx.length < 3) {
        System.out.println("It is not a face ...");
        return;
     }
   }

  /**
   * The constructor of J3DFace. 
   * if b is true, then calc normal
   */
  public J3DFace(J3DVertex[] vtx, boolean b) {
     vertex = new J3DVertex[vtx.length];
     System.arraycopy(vtx, 0, vertex, 0, vtx.length);

     if (vtx.length < 3) {
        System.out.println("It is not a face ...");
        return;
     }

     if (b) {
        normal = new Vector3f();
        Vector3f v1 = new Vector3f();
        Vector3f v2 = new Vector3f();

        Point3f[] pts = new Point3f[3];
        for (int i=0; i<3; i++) 
           pts[i] = new Point3f(vertex[i].x, vertex[i].y, vertex[i].z);

        v1.sub(pts[1], pts[0]);
        v2.sub(pts[2], pts[0]);
        normal.cross(v1, v2);
	//        normal.normalize();
     }
  }


  /**
   * return vertices
   */
  public Point3f[] getVertices() {
      Point3f pts[] = new Point3f[4];
      // assume that the number of vertex is 4
      for (int i=0; i<4; i++) 
         pts[i] = new Point3f(vertex[i].x, vertex[i].y, vertex[i].z);
      return pts;
  }

  /**
   * return normals
   */
  public Vector3f[] getNormals() {
      return normal2;
  }

  /**
   * return triangle vertices
   */
  public Point3f[] getTriVertices() {
      Point3f pts[] = new Point3f[3];
      // assume that the number of vertex is 3
      for (int i=0; i<3; i++) 
         pts[i] = new Point3f(vertex[i].x, vertex[i].y, vertex[i].z);
      return pts;
  }

  /**
   * return zvalue information for vertices
   */
  public float[] getZInfo() {
      float pts[] = new float[4];
      // assume that the number of vertex is 4
      for (int i=0; i<4; i++) 
         pts[i] = vertex[i].z;
      return pts;
  }

} // end of class
     

