package sv.viewer;

import java.awt.*;

public class Animator implements Runnable {

  GFrame gframe;
  int speed = 10;
  boolean condition = true;

  Thread anim;

  public void start() {
    anim = new Thread(this);
    anim.setPriority(Thread.MIN_PRIORITY);
    anim.start();
  }

  public synchronized void stop() {
    condition = false;
    anim = null;
    notify();
  }

  public Animator(GFrame gf, int speed) {
    gframe = gf;
    this.speed = speed;
  }

  public void run() {
    while (condition) {

      try {
	if (speed > 0)
	 anim.sleep(speed);
      } catch (InterruptedException e) {
        System.out.println("Animation error...");
      }

      synchronized(this) {
        gframe.doNext(true);
      }
    }
  }
} // end of class
