package sv.viewer.builtin;

import java.awt.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class DisplayPanel extends com.sun.java.swing.JPanel {

  BranchGroup scene;

  /**
   * constructor
   * @param impl Implementation of the panel object such as 
   *             GFrame2D and GFrame3D
   */
  public DisplayPanel(DisplayImpl impl) {
    setLayout(new BorderLayout());
    Canvas3D canvas = new Canvas3D(null);
    add("Center", canvas);

    // create a scene and attach it to the virtual universe
    scene = impl.createSceneGraph(canvas);
    SimpleUniverse u = new SimpleUniverse(canvas);

    // This will move the ViewPlatform back a bit so the
    // objects in the scene can be viewed.
    u.getViewingPlatform().setNominalViewingTransform();

    u.addBranchGraph(scene);
  }

  /**
   * change back ground color
   */
  public void changeBGColor(Color3f c) {
     BoundingSphere bounds = 
           new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
                            
     Background bg = new Background(c);
     bg.setApplicationBounds(bounds);
     BranchGroup branch = new BranchGroup();
     branch.setCapability(BranchGroup.ALLOW_DETACH);
     branch.addChild(bg);
     scene.setChild(branch, 1);
  }

  /**
   * change rendering option
   */
  public void changeDisplayOption(BranchGroup group) {
     TransformGroup tg = (TransformGroup)scene.getChild(4);
     tg.removeChild(0);
     tg.insertChild(group, 0);
  }

} // end of class      

