package sv.viewer.builtin;

import java.awt.*;
import java.util.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import sv.data.*;
import sv.gui.*;
import sv.util.*;

public class LabelInputDialog extends Dialog implements ActionListener {

  // labels to be changed
  String labels[];
  boolean[] isRotate = { false, false };

  TextField tfs[];
  Checkbox xcb, ycb;

  public LabelInputDialog(Frame frame, String[] lbls) {

    super(frame, "Label Change", true);   // make it modal
    labels = lbls;
    tfs = new TextField[2];

    makeGUI();
    pack();
  }

  public void actionPerformed(ActionEvent e) {
    String command = e.getActionCommand();

    if (command.equals("Apply")) {
      for (int i = 0; i < tfs.length; i++)
          labels[i] = tfs[i].getText().trim();

      if (xcb.getState()) isRotate[0] = true;
      else                isRotate[0] = false;
      if (ycb.getState()) isRotate[1] = true;
      else                isRotate[1] = false;

      dispose();

    } else if (command.equals("Clear")) {
      for (int j = 0; j < tfs.length; j++)
          tfs[j].setText("");
      return;
    } else if (command.equals("Cancel")) {
      labels = null;
      dispose();
    }
  }

  public String[] getArgs() {
    if (labels == null || labels[0].length() < 1 ||
                         labels[1].length() < 1)
       return null;

    String[] args = new String[4];

    args[0] = labels[0];
    args[1] = labels[1];
    args[2] = String.valueOf(isRotate[0]);
    args[3] = String.valueOf(isRotate[1]);

    return args;
  }

  private void makeGUI() {
    JPanel p;

    setLayout(new BorderLayout());

    JPanel centerp = new JPanel();
    centerp.setLayout(new GridLayout(2, 1));

    JPanel p1 = new JPanel();
    p1.setLayout(new GridLayout(2, 1));
    p1.setBorder(new TitledBorder("X Axis Label"));

    p = new JPanel();
    p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));
    p.add(new Label("X Axis Label: "));
    p.add(tfs[0] = new TextField(15));
    tfs[0].setText(labels[0]);
    p1.add(p);

    p1.add(xcb = new Checkbox("Rotate 90 degree", isRotate[0]));
   
    JPanel p2 = new JPanel();
    p2.setLayout(new GridLayout(2, 1));
    p2.setBorder(new TitledBorder("Y Axis Label"));

    p = new JPanel();
    p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));
    p.add(new Label("Y Axis Label: "));
    p.add(tfs[1] = new TextField(15));
    tfs[1].setText(labels[1]);
    p2.add(p);

    p2.add(ycb = new Checkbox("Rotate 90 degree", isRotate[1]));
   
    centerp.add(p1);
    centerp.add(p2);

    // button panel
    Panel btnp = new Panel();
    btnp.setLayout(new FlowLayout(FlowLayout.RIGHT, 5, 5));

    Button btn = new Button("Apply");
    btn.addActionListener(this);
    btnp.add(btn);

    btn = new Button("Clear");
    btn.addActionListener(this);
    btnp.add(btn);

    btn = new Button("Cancel");
    btn.addActionListener(this);
    btnp.add(btn);

    add("Center", centerp);
    add("South", btnp);
  }
} // end of class LabelInputDialog
