package sv.viewer.builtin;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

/**
 * for Zoom manipulators.
 */

public class ZoomBehavior extends Behavior {

  TransformGroup transformGroup;

  boolean reset = false;
  boolean debug = true;

  /**
   * Initializes standard fields.
   * @param transformGroup The transform group to be manipulated.
   */
  public ZoomBehavior(TransformGroup transformGroup) {
    super();

    this.transformGroup = transformGroup;
    reset = true;
  }
 
  /** 
   * Swap a new transformGroup replacing the old one. This allows 
   * manipulators to operate on different nodes.
   * 
   * @param transformGroup The *new* transform group to be manipulated.
   */
  public void setTransformGroup(TransformGroup transformGroup){
    // need to remove old behavior from group 
    this.transformGroup = transformGroup;
    reset = true;
  }

  /** Initializes the behavior.
   */
  public void initialize() {
  }
  
  /** 
   * Manually wake up the behavior. 
   */
  public void wakeup(float val) {
      //System.out.println("value = " + val);
      Matrix4d mat = new Matrix4d();

      Transform3D currXform = new Transform3D();
      transformGroup.getTransform(currXform);

      currXform.get(mat);
      mat.m23 = val * 0.2;
      currXform.set(mat);

      transformGroup.setTransform(currXform);
  }

  /**
   * All mouse manipulators must implement this.
   */
  public void processStimulus (Enumeration criteria) {
     System.out.println("processStimulus");
  }
}


