/*************************************************************************

	File Name	: HostSelection.java

	Function	: Get the host for SV2

	Input		:

**************************************************************************/

import java.awt.*;
import java.util.*;
import java.lang.*;
import java.awt.event.*;
import java.applet.Applet;

public class HostSelection extends Panel {

  selectionMain s2main;
	startSV2 smain;

	// items
	Choice serverNames;

	java.awt.List ItemList;
	Button okButton;
	Button cancelButton;

 	// message variables
	String messageSpace	= " ";

	String messageToBeSent	= null;
	String messageHead	= "1";
	String messageTotalData	= null;
	String messageAdd	= "11";
	String messageDelete	= "12";
	String messageClear	= "13";
	String messageHistory	= "14";
	String messageBody	= null;
	String messageEnd	= "kimd";

       /*****************************************************************
	*
	*	method	 : maketitle()
	*	Input    : String name,
	*		   GridBagLayout gridbag,
	*		   GridBagConstraints c
	*	Output   : none
	*	Function : make a title of this class
	*
	*****************************************************************/
	protected void maketitle(
				String name,
				GridBagLayout gridbag,
				GridBagConstraints c) {
		c.anchor = GridBagConstraints.SOUTH;

		Label label = new Label(name);

		// Font for Panel Title
		label.setFont(new Font("Dialog", Font.BOLD, 10));
		gridbag.setConstraints(label, c);
		add(label);
	}

       /*****************************************************************
	*
	*	method	 : makelabel()
	*	Input    : String name,
	*		   GridBagLayout gridbag,
	*		   GridBagConstraints c
	*	Output   : none
	*	Function : make a label
	*
	*****************************************************************/
	protected void makelabel(
				String name,
				GridBagLayout gridbag,
				GridBagConstraints c) {
		c.anchor = GridBagConstraints.SOUTH;

		Label label = new Label(name);

		// Font for label
		label.setFont(new Font("Dialog", Font.PLAIN, 8));

		gridbag.setConstraints(label, c);
		add(label);
	}

       /*****************************************************************
	*
	*	method	 : HostSelection()
	*
	*	Function : constructor of this class
	*
	*****************************************************************/
	HostSelection(startSV2 smain, selectionMain s2main) {

		this.smain = smain;
		this.s2main = s2main;

		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridbag);

		// Font for Panel Main
		setFont(new Font("Dialog", Font.PLAIN, 10));

		c.fill = GridBagConstraints.BOTH;

		// 1st line
		c.gridwidth = 3;                //reset to the default
		c.gridwidth = GridBagConstraints.RELATIVE;
		c.gridwidth = GridBagConstraints.REMAINDER; //end row
		c.weightx = 1.0;
		c.weighty = 0;
		c.insets = new Insets(0, 0, 0, 0);
		c.anchor = GridBagConstraints.SOUTH;

		serverNames = new Choice();
		serverNames.addItem("osprey1.npac.syr.edu");
		serverNames.addItem("osprey2.npac.syr.edu");
		serverNames.addItem("osprey3.npac.syr.edu");
		serverNames.addItem("osprey4.npac.syr.edu");
		serverNames.addItem("osprey5.npac.syr.edu");
		serverNames.addItem("osprey6.npac.syr.edu");
		serverNames.addItem("osprey7.npac.syr.edu");
		serverNames.addItem("osprey8.npac.syr.edu");
		add(serverNames);
		gridbag.setConstraints(serverNames, c);

		// 2nd line
		// ok buttons
//		c.gridwidth = GridBagConstraints.REMAINDER;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.weighty = 1;
		c.ipadx = 0;

		okButton = new Button("OK");
		gridbag.setConstraints(okButton, c);
		add(okButton);

		cancelButton = new Button("cancel");
		gridbag.setConstraints(cancelButton, c);
		add(cancelButton);
	}

	public boolean handleEvent(Event event) {

		if (event.target == okButton && event.id == Event.ACTION_EVENT) {
			okButton_Clicked();
		}
		else if (event.target == cancelButton && event.id == Event.ACTION_EVENT) {
			cancelButton_Clicked();
		}
		return false;
	}

	void okButton_Clicked() {
		s2main.hide();
		smain.isMaster = true;
		smain.serverName = serverNames.getSelectedItem();
		smain.accessServer("1");
	}

	void cancelButton_Clicked() {
		s2main.hide();
		smain.isMaster = false;
		smain.initApplet();
	}
}
