#include <jni.h>
#include "IsoFilter.h"
#include <stdio.h>
#include <stdlib.h>

#define NoInt   10
#define NoFloat 20

JNIEXPORT void JNICALL Java_IsoFilter_executeFilter
(JNIEnv *env, jobject obj) {

  int num_int;
  int num_float;
  long test_int1[NoInt];
  float test_float2[3][NoFloat];
  float test_float3[3][NoFloat];

  int i;

  jlongArray newIntArray1;
  jfloatArray newFloatArray20;
  jfloatArray newFloatArray21;
  jfloatArray newFloatArray22;
  jfloatArray newFloatArray30;
  jfloatArray newFloatArray31;
  jfloatArray newFloatArray32;


  jclass cls = (*env)->GetObjectClass(env, obj);
  jmethodID mid = (*env)->GetMethodID(env, cls, "callback", "(II[I[F[F[F[F[F[F)V");
  if (mid == 0) {
    return;
  }

  printf("<IsoFilterImp> method exist\n");

  num_int = NoInt;
  num_float = NoFloat;

  newIntArray1 = (*env)->NewIntArray(env, num_int);
  newFloatArray20 = (*env)->NewFloatArray(env, num_float);
  newFloatArray21 = (*env)->NewFloatArray(env, num_float);
  newFloatArray22 = (*env)->NewFloatArray(env, num_float);
  newFloatArray30 = (*env)->NewFloatArray(env, num_float);
  newFloatArray31 = (*env)->NewFloatArray(env, num_float);
  newFloatArray32 = (*env)->NewFloatArray(env, num_float);

  for ( i = 0 ; i < num_int ; i++ ) {
    test_int1[i] = i * 100000000;
  }

  for ( i = 0 ; i < num_float ; i++ ) {
    test_float2[0][i] = (float)(i * 1.0);
    test_float2[1][i] = (float)(i * 2.0);
    test_float2[2][i] = (float)(i * 3.0);

    test_float3[0][i] = (float)(i * 10.0);
    test_float3[1][i] = (float)(i * 20.0);
    test_float3[2][i] = (float)(i * 30.0);
  }

  (*env)->SetIntArrayRegion(env, newIntArray1, 0, num_int, (jint*)test_int1);

  (*env)->SetFloatArrayRegion(env, newFloatArray20, 0, num_float, (jfloat*)test_float2[0]);
  (*env)->SetFloatArrayRegion(env, newFloatArray21, 0, num_float, (jfloat*)test_float2[1]);
  (*env)->SetFloatArrayRegion(env, newFloatArray22, 0, num_float, (jfloat*)test_float2[2]);

  (*env)->SetFloatArrayRegion(env, newFloatArray30, 0, num_float, (jfloat*)test_float3[0]);
  (*env)->SetFloatArrayRegion(env, newFloatArray31, 0, num_float, (jfloat*)test_float3[1]);
  (*env)->SetFloatArrayRegion(env, newFloatArray32, 0, num_float, (jfloat*)test_float3[2]);

  (*env)->CallVoidMethod(env, obj, mid,
			 (jint)num_int, (jint)num_float,
			 newIntArray1,
			 newFloatArray20, newFloatArray21, newFloatArray22, 
			 newFloatArray30, newFloatArray31, newFloatArray32);
}
